#include<stdio.h>
#include<string.h>
#include<stdlib.h>

typedef struct drvo{
	char tip[20];
	char naziv[20];
	int broj;
	int balans;
	struct drvo *levi, *desni;
}drvo;

#define novi(x) x=(drvo *)malloc(sizeof(drvo));

void ispis(drvo *p){
	if(p){
		if(p->levi) ispis(p->levi);
		printf("%s\t%s\t%d\t%d\n", p->tip, p->naziv, p->broj, p->balans);
		if(p->desni) ispis(p->desni);
	}
}

int dubina(drvo *p){
	int dd=0; int dl=0;
	if(p){
		if(p->desni) dd=dubina(p->desni);
		if(p->levi) dl=dubina(p->levi);
		if(dd>dl) return ++dd;
		else return ++dl;
	}
}

void lrot(drvo **p){
	drvo *poml, *pomd;
	poml=*p;
	pomd=poml->desni;
	poml->desni=pomd->levi;
	pomd->levi=poml;
	*p=pomd;
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
}

void drot(drvo **p){
	drvo *poml, *pomd;
	pomd=*p;
	poml=pomd->levi;
	pomd->levi=poml->desni;
	poml->desni=pomd;
	*p=poml;
	pomd->balans=dubina(pomd->desni)-dubina(pomd->levi);
	poml->balans=dubina(poml->desni)-dubina(poml->levi);
}

int dodaj(drvo **p, char tip[], char naziv[], int broj){
	int rez=0;
	int ink;
	drvo *pom=*p;
	if(pom==NULL){
		novi(pom);
		strcpy(pom->tip, tip);
		strcpy(pom->naziv, naziv);
		pom->broj=broj;
		pom->levi=pom->desni=NULL;
		pom->balans=0;
		rez=1;
	}
	else{
		if(strcmp(tip, pom->tip)>=1) ink=dodaj(&(pom->desni), tip, naziv, broj);
		else if((strcmp(tip, pom->tip)==0) && (strcmp(naziv, pom->naziv)>=1))
		ink=dodaj(&(pom->desni), tip, naziv, broj);
		else ink=-dodaj(&(pom->levi), tip, naziv, broj);
		pom->balans=pom->balans+ink;
		if(pom->balans!=0 && ink!=0){
			if(pom->balans<-1){
				if(pom->levi->balans<0) drot(&pom);
				else{
					lrot(&(pom->levi));
					drot(&pom);
				}
			}
			else if(pom->balans>1){
				if(pom->desni->balans>0) lrot(&pom);
				else{
					drot(&(pom->desni));
					lrot(&pom);
				}
			}
			else rez=1;
		}
	}
	*p=pom;
	return rez;
} 

drvo *form(drvo *p, int n){
	int i;
	p=NULL;
	char tip[20];
	char naziv[20];
	int broj;
	for(i=0;i<n;i++){
		scanf("%s", tip);
		scanf("%s", naziv);
		scanf("%d", &broj);
		dodaj(&p, tip, naziv, broj);
	}
	return p;
}

int koliko(drvo *p, char tip[], int broj){
	int ukupno=0;
	if(p){
		if((strcmp(tip, p->tip)==0) && (p->broj<broj))
		ukupno=ukupno+1;
		if(p->desni) koliko(p->desni, tip, broj);
		if(p->levi) koliko(p->levi, tip, broj);
	}
	return ukupno;
	//printf("ukupno %d\n", ukupno);
}



/*void brisi(drvo *p, drvo **q, ink k){
	*/

main(){
	drvo *p;
	int n;
	scanf("%d", &n);
	p=form(p, n);
	ispis(p);
	printf("------------------------------\n");
	char type[20];
	int num;
	scanf("%s",type);
	scanf("%d", &num);
	int s=koliko(p, type, num);
	printf("%d\n", s);
}  
