#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct proizvod
{
	char tip[20];
	char naziv[20];
	int broj;
	int balans;
	struct proizvod *levi, *desni;
}proizvod;

#define novi(x) x = (proizvod*)malloc(sizeof(proizvod))

proizvod *form(int);
int dodaj(proizvod **, char[20],char[20],int);
void lrotacija(proizvod**);
void drotacija(proizvod**);
int dubina(proizvod *);
void ispis(proizvod *);

proizvod *form(int n)
{
	proizvod *koren = NULL;
	char im[20];
	char ti[20];
	int br;
	int i;
	for(i = 0; i < n; i++)
	{
		gets(ti);
		gets(im);
		scanf("%d",&br);
		getchar();
		dodaj(&koren,ti,im,br);
	}
	return koren;
}

void lrotacija(proizvod **t)
{
	proizvod *poml, *pomd;
	poml = *t;
	pomd = poml->desni;
	poml->desni = pomd->levi;
	pomd->levi = poml;
	*t = pomd;
	
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
}
void drotacija(proizvod **t)
{
	proizvod *poml, *pomd;
	pomd = *t;
	poml = pomd->levi;
	pomd->levi = poml->desni;
	poml->desni = pomd;
	*t = poml;
	
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
}

int dodaj(proizvod **p, char ti[20], char im[20], int br)
{
	int rez,inkr;
	proizvod *t = *p;
	if(t == NULL)
	{
		novi(t);
		strcpy(t->tip,ti);
		strcpy(t->naziv,im);
		t->broj = br;
		int balans = 0;
		t->levi = t->desni = NULL;
		rez = 1;
	}
	else
	{
		if(ti[0] < t->tip[0]) inkr = -dodaj(&(t->levi),ti,im,br);
		else if(ti[0] > t->tip[0]) inkr = dodaj(&(t->desni),ti,im,br);
		else
		{
			if(im[0] < t->naziv[0]) inkr = -dodaj(&(t->levi),ti,im,br);
			else inkr = dodaj(&(t->desni),ti,im,br);
		}
		
		t->balans += inkr;
		if(inkr != 0 && t->balans !=0)
		{
			if(t->balans < -1)
			{
				if(t->levi->balans < 0) drotacija(&t);
				else
				{
					lrotacija(&(t->levi));
					drotacija(&t);
				}
			}
			else if(t->balans > 1)
			{
				if(t->desni->balans > 0) lrotacija(&t);
				else
				{
					drotacija(&(t->desni));
					lrotacija(&t);
				}
			}
			else
			rez = 1;
		}
	}
	*p = t;
	return rez;
}

int dubina(proizvod *p)
{
	int dd = 0, dl = 0;
	if(p)
	{
		if(p->levi) dl = dubina(p->levi);
		if(p->desni) dd = dubina(p->desni);
		if(dl > dd) return ++dl;
		else return ++dd;
	}
}

void ispis(proizvod *p)
{
	if(p)
	{
		ispis(p->levi);
		printf("tip: %s\nnaziv: %s\nbroj komada: %d\n",p->tip,p->naziv,p->broj);
		ispis(p->desni);
	}
}

proizvod *brisi(proizvod *p, proizvod **q, char ti[20], char im[20], int br)
{
	if(p)
	{
		brisi(p->levi,q,ti,im,br);
		if((!strcmp(ti,p->tip)) && (!strcmp(im,p->naziv)) && (br-p->broj < 0))
		dodaj(q,p->tip,p->naziv,p->broj - br);
		else dodaj(q,p->tip,p->naziv,p->broj);
		brisi(p->desni,q,ti,im,br);
	}
}
/*
int koliko(proizvod *p, char ti[20], int p)
{
	int br = 0;
	if(p)
	{
		if(p->levi) br = koliko(p->levi,ti,p);
		if(p->desni) br = koliko(p->desni,ti,p);
		if((!strcmp(ti,p->tip)) && (p->broj < p)) return ++br;
		else return 0;
	}
}
*/
		
main()
{
	proizvod *p;
	proizvod *q = NULL;
	proizvod *a;
	int n;
	int k,i;
	char im[20];
	char ti[20];
	int br;
	printf("unesite n\n");
	scanf("%d",&n);
	getchar();
	p = form(n);
	ispis(p);
	/*
	printf("unesite k\n");
	scanf("%d",&k);
	getchar();
	for(i = 0; i < k; i++)
	{
		gets(ti);
		gets(im);
		scanf("%d",&br);
		getchar();
		brisi(p,&q,ti,im,br);
	}
	ispis(q);
	
	gets(ti);
	scanf("%d",&br);
	printf("broj proizvoda je %d\n",koliko(p,ti,10); */
}


				
