#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct lista
{
	char ime[15];
	int hleb;
	int pecivo;
	int poeni;
	struct lista *sledeci;
}lista;

lista *dodaj(lista *p, char ime[], int hleb,int pecivo, int poeni)
{
	lista *novi;
	
	novi=(lista*)malloc(sizeof(lista));
	strcpy(novi->ime,ime);
	novi->hleb=hleb;
	novi->pecivo=pecivo;
	novi->poeni=poeni;
	novi->sledeci=NULL;
	
	if(p==NULL)
	  p=novi;
	else
	{
		lista *trenutni=p;
		while(trenutni->sledeci!=NULL)
		  trenutni=trenutni->sledeci;
		
		trenutni->sledeci=novi;
		
	}
	return p;
}	    


lista *Formiraj()
{
	lista *p=NULL;
	printf("Unesite broj kupaca prvog dana\n");
	int n;
	scanf("%d",&n);
	int i;
	char ime[15];
	int hleb,pecivo,poeni;
	int p1,p2;
	printf("Unesite podatke o kupcima\n");
	for(i=0;i<n;i++)
	{
		scanf("%s",ime);
		scanf("%d",&hleb);
		scanf("%d",&pecivo);
		p1=hleb/2;
		p2=pecivo/1;
		if(p1>p2) poeni=p2;
		 else poeni=p1;
		p=dodaj(p,ime,hleb,pecivo,poeni);
	}
	return p;
}


void Ispis(lista *p)
{
	while(p!=NULL)
	{
		printf("ime: %s hleb: %d  pecivo: %d  poeni: %d\n",p->ime,p->hleb,p->pecivo,p->poeni);
		p=p->sledeci;
	}
	
}  

lista* NaknadnoDodaj(lista *p, char ime[], int hleb, int pecivo, int poeni)
{
	lista *trenutni=p,*prethodni=NULL;
	
	while(trenutni!=NULL)
	{
		if(strcmp(trenutni->ime,ime)==0)
		  {
			  trenutni->poeni+=poeni;
			  trenutni->hleb+=hleb;
			  trenutni->pecivo+=pecivo;
		      return p;
		  }
		prethodni=trenutni;
		trenutni=trenutni->sledeci;
	}
	if(trenutni==NULL)
	{
		lista *novi;
		novi=(lista*)malloc(sizeof(lista));
		strcpy(novi->ime,ime);
		novi->hleb=hleb;
		novi->pecivo=pecivo;
		novi->poeni=poeni;
		prethodni->sledeci=novi;
		return p;
	}
	return p;
}   
	
	
lista *Nadji(lista *p, int poeni)
{
	lista *pob=NULL;
	
	while(p!=NULL)
	{
		if(p->poeni>=poeni)
		  pob=p;
		p=p->sledeci;
	}
	
	return pob;
	
}  	



int main()
{
	lista *p;
	p=NULL;
	p=Formiraj();
	
	Ispis(p);
	int k,p1,p2,hleb,pecivo,poeni,i;
	char ime[15];

	printf("Unesite koliko jos dana traje nagradna igra\n");
	int dan,j;
	scanf("%d",&dan);
	for(j=1;j<dan;j++)
	{
		printf("Unesite koliko je kupaca doslo %d-og dana\n",j+1);
		scanf("%d",&k);
		printf("Unesite podatke o kupcima\n");
		for(i=0;i<k;i++)
		{
			scanf("%s",ime);
			scanf("%d",&hleb);
			scanf("%d",&pecivo);
			p1=hleb/2;
			p2=pecivo/1;
			if(p1<p2) poeni=p1;
			else poeni=p2;
			p=NaknadnoDodaj(p,ime,hleb,pecivo,poeni);
		}
		Ispis(p);
	}
	printf("Koliko poena predstavlja minimum za pobedu\n");
	scanf("%d",&poeni);
	lista *pobednik=NULL;
	pobednik=Nadji(p,poeni);
	if(pobednik==NULL)
	{
		printf("Nema pobednika! Niko nije skupio bar %d poena\n",poeni);
		return 0;
	}
	printf("Pobednik je %s sa %d poena!\n",pobednik->ime,pobednik->poeni);
	return 0;
}
