#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct drvo
{
	int broj;
	int br_cifara;
	struct drvo *levi, *desni;
};

#define novi(x) x=(struct drvo *)malloc(sizeof(struct drvo))

int broj_cifara(int x)
{
	int a[10], i, j, br=0, b;
	for(i=0; i<10; i++)
		a[i]=0;
	while(x)
	{
		b=x%10;
		for(j=0; j<10; j++)
			if(b==j)
				a[j]=1;
		x=x/10;
	}
	for(i=0; i<10; i++)
		if (a[i]==1)
			br++;
	return br;
}

void dodaj(struct drvo **p, struct drvo *cvor)
{
	struct drvo *pom, *pom1;
	int ind;
	pom=*p;
	if(!pom)
	{
		*p=cvor;
	}
	else
	{
		while(pom)
		{
			pom1=pom;
			if(pom->br_cifara < cvor->br_cifara)
			{
				pom=pom->levi;
				ind=0;
			}
			else if(pom->br_cifara > cvor->br_cifara)
			{
				pom=pom->desni;
				ind=1;
			}
			else
			{
				if(pom->broj < cvor->broj)
				{
					pom=pom->levi;
					ind=0;
				}
				else
				{
					pom=pom->desni;
					ind=1;
				}
			}
		}
		if (ind)
			pom1->desni=cvor;
		else
			pom1->levi=cvor;
	}
}

struct drvo * form()
{
	struct drvo *koren=NULL, *cvor;
	int n, i;
	printf("Unesite broj N: ");
	scanf("%d",&n);
	for(i=0; i<n; i++)
	{
		novi(cvor);
		cvor->levi=cvor->desni=NULL;
		printf("Unesite broj: ");
		scanf("%d",&cvor->broj);
		cvor->br_cifara=broj_cifara(cvor->broj);
		dodaj(&koren,cvor);
	}
	return koren;
}

void ispis(struct drvo *p)
{
	if(p)
	{
		ispis(p->levi);
		printf("%d ima %d razlicitih cifara\n",p->broj,p->br_cifara);
		ispis(p->desni);
	}
}

void zbir(struct drvo *p, int k, int c, int *zb)
{
	if(p)
	{
		zbir(p->levi,k,c,zb);
		if((p->broj > k) && (p->br_cifara < c))
			zb+=p->broj;
		zbir(p->desni,k,c,zb);
	}
}

main()
{
	struct drvo *koren;
	int k, c, zb=0;
	koren=form();
	ispis(koren);
	printf("Unesite broj K: ");
	scanf("%d",&k);
	printf("Unesite broj C: ");
	scanf("%d",&c);
	zbir(koren,k,c,&zb);
	printf("Zbir je %d",zb);
}
