#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct kupac
{
	char ime[50];
	int b_hleb, b_pecivo, b_poena;
	struct kupac *sled;
};

#define novi(x) x=(struct kupac *)malloc(sizeof(struct kupac))

struct kupac *formiraj(void);
void dodaj(struct kupac **p, char *ime, int b_hleb, int b_pecivo);
void ispis(struct kupac *p);
struct kupac *nagrada(struct kupac *p, int b);

int main(void)
{
	struct kupac *p, *pom;
	int n, b_hleb,b_pecivo;
	char ime[50];
	int k,d,i,j;
	p=formiraj();
	ispis(p);
	printf("-------------\n");
	printf("Unesite broj dana: ");
	scanf("%d",&d);
	for (i=0; i<d; i++)
	{
		printf("Unesite broj kupaca ovog dana: ");
		scanf("%d",&k);
		getchar();
		for (j=0; j<k; j++)
		{
			scanf("%s",ime);
			scanf("%d",&b_hleb);
			scanf("%d",&b_pecivo);
			getchar();
			pom=p;
			while (pom)
			{
				if (!strcmp(pom->ime,ime))
				{
					pom->b_hleb+=b_hleb;
					pom->b_pecivo+=b_pecivo;
					if (b_pecivo/2<b_hleb)
						pom->b_poena+=b_pecivo/2;
					else
						pom->b_poena+=b_hleb;
					break;
				}
				pom=pom->sled;
			}
			if (!pom)
				dodaj(&p,ime,b_hleb,b_pecivo);
		}
		ispis(p);
		printf("-------------\n");
	}
	int b;
	printf("Unesite broj b: ");
	scanf("%d",&b);
	struct kupac *ko;
	ko=nagrada(p,b);
	if (ko==NULL)
		printf("Niko ne zadovoljava uslov\n");
	else
		printf("Igrac koji je osvoji nagradu: %s sa %d poena\n",ko->ime,ko->b_poena);
	return 0;
}

void dodaj(struct kupac **p, char *ime, int b_hleb, int b_pecivo)
{
	struct kupac *pom, *temp;
	novi(temp);
	strcpy(temp->ime,ime);
	temp->b_hleb=b_hleb;
	temp->b_pecivo=b_pecivo;
	if (b_pecivo/2<b_hleb)
		temp->b_poena=b_pecivo/2;
	else
		temp->b_poena=b_hleb;
	temp->sled=NULL;
	if (!(*p))
		*p=temp;
	else
	{
		pom=*p;
		while (pom->sled!=NULL)
			pom=pom->sled;
		pom->sled=temp;
	}
}

struct kupac *formiraj(void)
{
	struct kupac *p=NULL;
	int n, b_hleb,b_pecivo;
	char ime[50];
	scanf("%d",&n);
	getchar();
	while (n--)
	{
		scanf("%s",ime);
		scanf("%d",&b_hleb);
		scanf("%d",&b_pecivo);
		getchar();
		dodaj(&p,ime,b_hleb,b_pecivo);	
	}
	return p;
}

void ispis(struct kupac *p)
{
	while (p)
	{
		printf("Ime: %s\n",p->ime);
		printf("B_hleb: %d\n",p->b_hleb);
		printf("B_pecivo: %d\n",p->b_pecivo);
		printf("B_poena: %d\n",p->b_poena);
		p=p->sled;
	}
}

struct kupac *nagrada(struct kupac *p, int b)
{
	struct kupac *ko=NULL;
	while (p)
	{
		if (p->b_poena>=b)
			ko=p;
		p=p->sled;
	}
	return ko;
	
}
