#include<stdio.h>
#include<string.h>
#include<stdlib.h>


typedef struct dr
{
      int broj, cifre;
      struct dr *levi, *desni;
}drvo;

#define novi(x) x = (drvo *)malloc(sizeof(drvo))

drvo *form();
void ispis(drvo *, int);
void dodaj(drvo **, int, int);
int trazi(drvo *, int, int);

main()
{
       int zbir, k, c;
       drvo *p;
       p=form();
       ispis(p, 1);
       
       printf("Unesi k i c\n");
       scanf("%d%d", &k, &c);
       zbir = trazi(p, k, c);
       printf("Zbir %d", zbir);
       
}

drvo *form()
{
       drvo *koren;
       koren = NULL;
       int broj,cifre, n, i;
       printf("Unesi koliko brojeva ima ");
       scanf("%d", &n);
       for(i=0; i<n; i++)
       {
	      printf("Unesi broj");
	      scanf("%d", &broj);
	      printf("Koliko razl cifara ima ");
	      scanf("%d", &cifre);
	      
	      dodaj(&koren, broj, cifre);
       }
       return koren;  
}

void ispis(drvo *p, int i)
{
       if(p==NULL)
	      return;
       else
       {
	      ispis(p->desni, i+1);
	      printf("Nivo- %d.  Broj %d, razlicite cifre %d \n", i,p->broj, p->cifre);
	      ispis(p->levi, i+1);
       }
}

void dodaj(drvo **p, int broj, int cifre)
{
       drvo *pom1, *pom2;
       drvo *temp = *p;
       novi(temp);
       if((temp)==NULL)
       {
	      printf("Greska pri alokaciji\n");
	      exit(0);
       }
       (temp)->broj = broj;
       (temp)->cifre = cifre;
       (temp)->levi = (temp)->desni = NULL;
       
       if(temp)
       {
	      pom1=(temp);
       }
       
       while(pom1)
       {
	      pom2 = pom1;
	      if((temp->cifre<cifre) || ((temp->cifre == cifre) && (temp->broj<broj)))
		     pom1=pom1->desni;
	      else
		     pom1=pom1->levi;
	      
	      if(pom2->cifre<cifre)
		     pom2->levi=temp;
	      else 
		     pom2->desni=temp;
       }
}

int trazi(drvo *p, int k, int c )
{
       int br = 0;
       if(p==NULL)
	      return;
       if((p->broj>k) && (p->cifre<c))
       {
	     if(p->levi)
		     br += trazi(p->levi,k,c);
	      if(p->desni)
		     br += trazi(p->desni, k, c);
       }
       return br;
}


