#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define novi(x) x=(kupci*)malloc(sizeof(kupci))

typedef struct kk
{
	char *ime;
	int bhleb;
	int bpecivo;
	int bpoena;
	struct kk *sledeci;
} kupci;

void ispis(kupci *q)
{
	while(q)
	{
		printf("%s %d %d %d\n",q->ime,q->bhleb,q->bpecivo,q->bpoena);
		q=q->sledeci;
	}
}

int Poeni(int hleb, int pecivo)
{
	int z=0;
	while((hleb>0)&&(pecivo>1))
	{
		z++;
		hleb--;
		pecivo-=2;
	}
	return z;
}

void dodaj(kupci **q,char *ime, int hleb, int pecivo)
{
	kupci *t,*pom;
	novi(t);
	t->ime=(char*)malloc(strlen(ime)+1);
	strcpy(t->ime,ime);
	t->bhleb=hleb;
	t->bpecivo=pecivo;
	t->bpoena=0;
	t->sledeci=NULL;
	t->bpoena=Poeni(hleb,pecivo);
	pom=(*q);
	if(pom==NULL) (*q)=t;
	else
	{
		while(pom->sledeci) pom=pom->sledeci;
		pom->sledeci=t;
	}
}

int main(int argc, char **argv)
{
	kupci *q,*pom,*w;
	q=NULL; w=NULL;
	char ime[100];
	int b,i,k,d,hle,pec;
	printf("Uneti kupce 1. dana\n");
	scanf("%d",&k);
	for(i=0;i<k;i++)
	{
		scanf("%s",ime);
		scanf("%d",&hle);
		scanf("%d",&pec);
		dodaj(&q,ime,hle,pec);
	}
	ispis(q);
	printf("Uneti broj dana takmicenja\n");
	scanf("%d",&d);
	for(i=0;i<d-1;i++)
	{
		printf("Uneti broj kupaca %d. dana\n",i+2);
		scanf("%d",&k);
		while(k)
		{
			scanf("%s",ime);
			scanf("%d",&hle);
			scanf("%d",&pec);
			k--;
			pom=q;
			while((pom!=NULL)&&(strcmp(pom->ime,ime))) pom=pom->sledeci;
			if(pom) 
			{
				pom->bhleb+=hle;
				pom->bpecivo+=pec;
				pom->bpoena+=Poeni(hle,pec);
			}
			else dodaj(&q,ime,hle,pec);
		}
		ispis(q);
	}
	printf("Uneti broj poena za nagradu\n");
	scanf("%d",&b);
	pom=q;
	while(pom)
	{
		if(pom->bpoena>=b) dodaj(&w,pom->ime,pom->bhleb,pom->bpecivo);
		pom=pom->sledeci;
	}
	if(w==NULL) printf("Niko nema dovoljan broj poena za nagradu\n");
	else {
		while(w->sledeci) w=w->sledeci;
		printf("Pobednik je:\n");
		printf("%s %d %d %d\n",w->ime,w->bhleb,w->bpecivo,w->bpoena);
	}
	
	return 0;
}

