#include <stdio.h>
#include <stdlib.h>
#include <string.h>

enum{CRNA,CRVENA};

typedef struct stablo{
	char *tip;
	char *naziv;
	int broj;
	int boja;
	struct stablo *roditelj,*levo,*desno;
	}stablo;

#define novi(x) x=(struct stablo *)malloc(sizeof(stablo));

void dodaj(stablo **p,stablo *z){
	struct stablo *tren, *pret;
	tren=*p;
	if(tren==NULL) *p=z;
	else{
		while(tren!=NULL){
			pret=tren;
			if((strcmp(tren->tip,z->tip)<0) || ((strcmp(tren->tip,z->tip)==0) && (strcmp(tren->naziv,z->naziv)<0)))//mozda znak jedino da se promeni radi stampe
			tren=tren->levo;//i strana 
			else tren=tren->desno;
		}
		if((strcmp(pret->tip,z->tip)<0) || ((strcmp(pret->tip,z->tip)==0) && (strcmp(pret->naziv,z->naziv)<0)))//mozda znak jedino da se promeni radi stampe
		pret->levo=z;//i strana
		else pret->desno=z;
		
		z->roditelj=pret;
	}
	bojefix(p,z);
}

void bojefix(struct stablo **p, struct stablo *z){
	struct stablo *y;
	while((z->roditelj)&&(z->roditelj->boja==CRVENA)){
		if(z->roditelj==z->roditelj->roditelj->levo){
			y=z->roditelj->roditelj->desno;
			if((y!=NULL)&&(y->boja==CRVENA)){
				z->roditelj->boja=CRNA;
				y->boja=CRNA;
				z=z->roditelj->roditelj;
				z->boja=CRVENA;
			}else{
				if(z==z->roditelj->desno){
					z=z->roditelj;
					lrotacija(&z);
					z=z->levo;
				}
				z->roditelj->boja=CRNA;
				z=z->roditelj->roditelj;
				z->boja=CRVENA;
				drotacija(&z);
				if(z->roditelj==NULL) *p=z;}}
		else{
			y=z->roditelj->roditelj->levo;
			if((y!=NULL)&&(y->boja==CRVENA)){
				z->roditelj->boja=CRNA;
				y->boja=CRNA;
				z=z->roditelj->roditelj;
				z->boja=CRVENA;}
			else{
				if(z==z->roditelj->levo){
					z=z->roditelj;
					drotacija(&z);
					z=z->desno;}
			z->roditelj->boja=CRNA;
			z=z->roditelj->roditelj;
			z->boja=CRVENA;
			lrotacija(&z);
			if(z->roditelj==NULL) *p=z;}}}
			(*p)->boja=CRNA;
}

void lrotacija(struct stablo **p){
	struct stablo *t, *pom;
	t=*p;
	pom=t->desno;
	t->desno=pom->levo;
	if(pom->levo) pom->levo->roditelj=t;
	pom->roditelj=t->roditelj;
	if(t->roditelj)
	if(t==t->roditelj->levo) t->roditelj->levo=pom;
	else t->roditelj->desno=pom;
	pom->levo=t;
	t->roditelj=pom;
	*p=pom;
}

void drotacija(struct stablo **p){
	struct stablo *t, *pom;
	t=*p;
	pom=t->levo;
	t->levo=pom->desno;
	if(pom->desno) pom->desno->roditelj=t;
	pom->roditelj=t->roditelj;
	if(t->roditelj)
	if(t==t->roditelj->desno) t->roditelj->desno=pom;
	else t->roditelj->levo=pom;
	pom->desno=t;
	t->roditelj=pom;
	*p=pom;
}

struct stablo *form(){
	struct stablo *koren=NULL,*z;
	int n,i;
	char s1[50],s[50];
	koren=NULL;
	printf("Unesi broj \n");
	scanf("%d",&n);
	getchar();
	for(i=0;i<n;i++){
		novi(z);
		printf("Unesi tip proizvoda\n");
		//scanf("%s",s);
		gets(s);
		z->tip=(char *)malloc(strlen(s)+1);
		strcpy(z->tip,s);
		printf("unesi naziv proizvoda\n");
		//scanf("%s",s);
		gets(s);
		z->naziv=(char *)malloc(strlen(s)+1);
		strcpy(z->naziv,s);
		printf("unesi broj komandi prozivoda\n");
		scanf("%d",&z->broj);
		z->boja=CRVENA;
		z->levo=z->desno=z->roditelj=NULL;
		getchar();
		dodaj(&koren,z);
	}
	return (koren);
}

void ispis(stablo *p){
	if(p!=NULL){
		ispis(p->levo);
		printf("%s %s %d\n",p->tip,p->naziv,p->broj);
		if(p->boja==CRVENA) printf("CRVENA");
		else printf("CRNA");
		ispis(p->desno);
	}
	printf("\n");
}

int nadji(stablo *p, char *s, int b,int suma)
{
	if(!p)
	{		
		return suma;
	}
	else{
		if((strcmp(p->tip,s)==0))
		{
			if(p->broj<b)
			suma+=1;
		}
		if(p->levo) nadji(p->levo,s,b,suma);
		if(p->desno) nadji(p->desno,s,b,suma);
	}
	return suma;
}

main(){
	stablo *p=NULL;
	int suma=0,b;
	char s[20];
	p=form();
	ispis(p);
	printf("---------------\n");
	printf("Unesi trazeni tip proizvoda\n");
	gets(s);
	//scanf("%s",s);
	printf("Uneti trazeni broj proizvoda\n");
	scanf("%d",&b);
	suma+=nadji(p,s,b,0);
	printf("ima ih %d \n",suma);
}
