#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct lista{
	char ime[30];
	int koraci;
	struct lista *prethodni,*sledeci;
}lista;

#define aloc(x) x=(lista*)malloc(sizeof(lista))

void dodaj(lista **p,lista **q,char ime[30],int koraci){
	lista *novi;
	aloc(novi);
	if(!novi){
		printf("Greska");
		exit(0);
	}
	strcpy(novi->ime,ime);
	novi->koraci=koraci;
	novi->sledeci=NULL;
	if(*p==NULL){
		*p=*q=novi;
		novi->prethodni=NULL;
	}
	else{
		(*q)->sledeci=novi;
		novi->prethodni=*q;
		*q=novi;
	}
}

void form(lista **p,lista **q){
	char ime[30];
	int koraci;
	int i,n;
	scanf("%d",&n);
	for (i = 0; i < n; i++)
	{
		scanf("%s",ime);
		scanf("%d",&koraci);
		dodaj(p,q,ime,koraci);
	}
}

void ispis(lista *p){
	while(p!=NULL){
		printf("%s %d\n",p->ime,p->koraci);
		p=p->sledeci;
	}
}

int main(){
	lista *p,*q;
	form(&p,&q);
	ispis(p);
	
	
	return 0;
}
