#include <stdio.h>
#include <stdlib.h>

struct cvor
{
	int broj;
	int broj_raz_cif;
	struct cvor *levi, *desni;
};

#define novi(x) x=(struct cvor *)malloc(sizeof(struct cvor))

int broj_raz(int br);
void ispis(struct cvor *p);
void zbir(struct cvor *p,int k, int c, int *zb);

int main(void)
{
	struct cvor *p=NULL, *pom1, *pom2, *temp;
	int n, broj, broj_raz_cif, i;
	printf("Unesite koliko brojeva zelite da unesete: ");
	scanf("%d",&n);	
	for (i=0; i<n; i++)
	{
		novi(temp);
		scanf("%d",&(temp->broj));
		temp->broj_raz_cif=broj_raz(temp->broj);
		temp->levi=temp->desni=NULL;
		if (!p)
			p=temp;
		else
		{
			pom1=p;
			while (pom1)
			{
				pom2=pom1;
				if (temp->broj_raz_cif<pom1->broj_raz_cif)
					pom1=pom1->levi;
				else if (temp->broj_raz_cif>pom1->broj_raz_cif)
					pom1=pom1->desni;
				else
				{
					if (temp->broj<pom1->broj)
						pom1=pom1->levi;
					else
						pom1=pom1->desni;
				}
			}
			if (temp->broj_raz_cif<pom2->broj_raz_cif)
				pom2->levi=temp;
			else if (temp->broj_raz_cif>pom2->broj_raz_cif)
				pom2->desni=temp;
			else
			{
				if (temp->broj<pom2->broj)
					pom2->levi=temp;
				else
					pom2->desni=temp;
			}
		}
	}
	ispis(p);
	int k,c;
	printf("---------------\n");
	printf("Unesite k:\n");
	scanf("%d",&k);
	printf("Unesite c:\n");
	scanf("%d",&c);
	int zb=0;
	zbir(p,k,c,&zb);
	printf("\nUkupan zbir brojeva %d\n",zb);
	return 0;
}

int broj_raz(int br)
{
	int b=0,tren;
	int i;
	int niz[10];
	for (i=0; i<10; i++)
		niz[i]=0;
	while (br)
	{
		tren=br%10;
		niz[tren]++;
		br/=10;
	}
	for (i=0; i<10; i++)
		if (niz[i]!=0)
			b++;
	return b;
}

void ispis(struct cvor *p)
{
	if (p)
	{
		if (p->desni)
			ispis(p->desni);
		printf("Broj %d\n",p->broj);
		printf("Broj %d\n",p->broj_raz_cif);
		if (p->levi)
			ispis(p->levi);
	}
}

void zbir(struct cvor *p,int k, int c, int *zb)
{
	if (p)
	{
		if (p->broj_raz_cif>=c)
			zbir(p->levi,k,c,zb);
		else
		{
			if (p->broj>k)
				*zb=*zb+p->broj;
			zbir(p->levi,k,c,zb);
			zbir(p->desni,k,c,zb);
		}
	}	
}
