#include <string.h>
#include <stdio.h>
#include <stdlib.h>

enum{CRVENA,CRNA};

struct drvo
{
	char *tip;
	char *naziv;
	int broj;
	int boja;
	struct drvo *levi,*desni,*roditelj;
};

typedef struct drvo proizvod;
#define novi(x) x=(proizvod *)malloc(sizeof(proizvod));

void lrotacija(proizvod **p)
{
	proizvod *pom,*pom1;
	pom=*p;
	pom1=pom->desni;
	pom->desni=pom1->levi;
	if(pom1->levi) pom1->levi->roditelj=pom;
	pom->roditelj=pom1->roditelj;
	if(pom1->roditelj)
			if(pom == pom->roditelj->levi) pom->roditelj->levi=pom1;
			else pom->roditelj->desni=pom1;
			pom1->levi = pom;
			pom->roditelj=pom1;
			*p=pom1;
}

void drotacija(proizvod **p)
{
	proizvod *pom,*pom1;
	pom=*p;
	pom1=pom->levi;
	pom->levi=pom1->desni;
	if(pom1->desni) pom1->desni->roditelj=pom;
	pom->roditelj=pom1->roditelj;
	if(pom1->roditelj)
			if(pom == pom->roditelj->desni) pom->roditelj->desni=pom1;
			else pom->roditelj->levi=pom1;
			pom1->desni = pom;
			pom->roditelj=pom1;
			*p=pom1;
}

void bojefix(proizvod **p,proizvod *z)
{
	proizvod *y,*t;
	while((z->roditelj) && (z->roditelj->boja==CRVENA))
	{
		if((z->roditelj) == (z->roditelj->roditelj->levi))
		{
			y=z->roditelj->roditelj->desni;
			if((y) && (y->boja == CRVENA))
			{
				z->roditelj->boja=CRNA;
				y->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				z=z->roditelj->roditelj;
			}
			else
			{
				if(z == z->roditelj->levi)
				{
					z=z->roditelj;
					lrotacija(&z);
					if(!z->roditelj) *p=z;
					z=z->levi;
				}
				z->roditelj->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				t=z->roditelj->roditelj;
				drotacija(&t);
				if(!t->roditelj) *p=t;
			}
		}
		else
		{
			y=z->roditelj->roditelj->levi;
			if((y) && (y->boja == CRVENA))
			{
				z->roditelj->boja=CRNA;
				y->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				z=z->roditelj->roditelj;
			}
			else
			{
				if(z == z->roditelj->desni)
				{
					z=z->roditelj;
					drotacija(&z);
					if(!z->roditelj) *p=z;
					z=z->desni;
				}
				z->roditelj->boja=CRNA;
				z->roditelj->roditelj->boja=CRVENA;
				t=z->roditelj->roditelj;
				lrotacija(&t);
				if(!t->roditelj) *p=t;
			}
		}
	}
	(*p)->boja=CRNA;
}

int zbir(proizvod *p,char t[],int P)
{
	proizvod *pom;
	int suma=0;
	pom=p;
	while(pom!=NULL)
	{
		if(strcmp(pom->tip,t) == 0)
		{
			if(pom->broj < P)
			{
				suma=suma+1;
				
			}
		}
		else return suma;
	}
	return suma;
}

void dodaj(proizvod **p,proizvod *z)
{
	proizvod *pom,*pom1;
	pom=*p;
	pom1=NULL;
	while(pom!=NULL)
	{
		pom1=pom;
		if(z->tip < pom->tip) pom=pom->desni;
		else
		{
			if(strcmp(z->tip,pom->tip) == 0)
			{
				if(z->naziv < pom->naziv) pom=pom->desni;
				else pom=pom->levi;
			}
			else pom=pom->levi;
		}
	}
	z->roditelj=pom1;
	if(!pom1)
	*p=z;
	else
	{
		if(z->tip < pom1->tip) pom1->desni=z;
		else
		{
			if(strcmp(z->tip,pom1->tip) == 0)
			{
				if(z->naziv < pom1->naziv) pom1->desni=z;
				else pom1->levi=z;
			}
			else pom1->levi=z;
		}
	}
	bojefix(p,z);
}

proizvod *form()
{
	proizvod *p=NULL,*z;
	char tip[100],naziv[100];
	int broj,i,n;
	
	printf("uneti broj razlicitih proizvoda n: ");
	scanf("%d",&n);
	for(i=0;i<n;i++)
	{
		printf("uneti tip proizvoda : ");
		scanf("%s",tip);
		printf("uneti naziv proizvoda : ");
		scanf("%s",naziv);
		printf("uneti broj komada tog proizvoda : ");
		scanf("%d",&broj);
		novi(z);
		z->levi=z->desni=z->roditelj=NULL;
		z->tip=(char *)malloc(strlen(tip) + 1);
		strcpy(z->tip,tip);
		z->naziv=(char *)malloc(strlen(naziv) + 1);
		strcpy(z->naziv,naziv);
		z->broj=broj;
		z->boja=CRVENA;
		dodaj(&p,z);
	}
	return p;
}

void ispis(proizvod *p)
{
	if(p!=NULL)
	{
		ispis(p->levi);
		printf("%s\t%s\t%d\t",p->tip,p->naziv,p->broj);
		if(p->boja==CRVENA) printf("CRVENA");
		else printf("CRNA");
		ispis(p->desni);
	}
	printf("\n");
}

main()
{
	proizvod *p=NULL;
	int P;
	char tip[100];
	p=form();
	ispis(p);
	printf("uneti tip proizvoda : ");
	scanf("%s",tip);
	printf("uneti broj proizvoda : ");
	scanf("%d",&P);
	printf("ukupno ima : %d",zbir(p,tip,P));
	
}
